﻿Sys.UI.PasswordStrengthCheckBehavior = function() {
    Sys.UI.PasswordStrengthCheckBehavior.initializeBase(this);
    
    var _keyPressHandler;
    var _checkResultLabelID;
    this.get_checkResultLabelID = function() {
        return _checkResultLabelID;
    }
    this.set_checkResultLabelID = function(value) {
        if (_checkResultLabelID != value) {
            _checkResultLabelID = value;
            this.raisePropertyChanged('checkResultLabelID');
        }
    }
    
    this.dispose = function() {
        this.control.element.detachEvent('onkeyup', _keyPressHandler);
        Sys.UI.PasswordStrengthCheckBehavior.callBaseMethod(this, 'dispose');
    }

    this.initialize = function() {
        Sys.UI.PasswordStrengthCheckBehavior.callBaseMethod(this, 'initialize');

        _keyPressHandler = Function.createDelegate(this, keyPressHandler);
        this.control.element.attachEvent('onkeyup', _keyPressHandler);
    }
    
    this.getDescriptor = function() {
        var td = Sys.UI.ClickBehavior.callBaseMethod(this, 'getDescriptor');
        td.addProperty('checkResultLabelID', String);
        return td;
    }
    
    function keyPressHandler() {
    
        // you may refactor this part to make the code more 'Atlas like' :-)
        var PasswordStrength ={
            Level : ["高，实在是高","还行啦","靠，这样也行"],
            LevelValue : [30,20,0],//强度值
            Factor : [1,2,5],//字符加数,分别为字母，数字，其它
            KindFactor : [0,0,10,20],//密码含几种组成的加数 
            Regex : [/[a-zA-Z]/g,/\d/g,/[^a-zA-Z0-9]/g] //字符正则数字正则其它正则
            }
        PasswordStrength.StrengthValue = function(pwd)
        {
            var strengthValue = 0;
            var ComposedKind = 0;
            for(var i = 0 ; i < this.Regex.length;i++)
            {
                var chars = pwd.match(this.Regex[i]);
                if(chars != null)
                {
                    strengthValue += chars.length * this.Factor[i];
                    ComposedKind ++;
                }
            }
            strengthValue += this.KindFactor[ComposedKind];
            return strengthValue;
        } 
        PasswordStrength.StrengthLevel = function(pwd)
        {
            var value = this.StrengthValue(pwd);
            for(var i = 0 ; i < this.LevelValue.length ; i ++)
            {
                if(value >= this.LevelValue[i] )
                    return this.Level[i];
            }
        }
        // end of the refactoring section
        
        $(_checkResultLabelID).innerHTML = PasswordStrength.StrengthLevel(this.control.element.value);
    }
}
Sys.UI.PasswordStrengthCheckBehavior.registerSealedClass('Sys.UI.PasswordStrengthCheckBehavior', Sys.UI.Behavior);
Sys.TypeDescriptor.addType('script', 'passwordStrengthCheckBehavior', Sys.UI.PasswordStrengthCheckBehavior);